diff --git a/tools/winegcc/winegcc.c b/tools/winegcc/winegcc.c
index 776d2b6473b..2b89e28671f 100644
--- a/tools/winegcc/winegcc.c
+++ b/tools/winegcc/winegcc.c
@@ -1078,7 +1078,6 @@ static void build(struct options* opts)
     const char *output_name, *spec_file, *lang;
     int generate_app_loader = 1;
     const char *crt_lib = NULL, *entry_point = NULL;
-    int fake_module = 0;
     int is_pe = (opts->target_platform == PLATFORM_WINDOWS || opts->target_platform == PLATFORM_CYGWIN || opts->target_platform == PLATFORM_MINGW);
     unsigned int j;
 
@@ -1101,11 +1100,13 @@ static void build(struct options* opts)
 	return;
     }
 
+    /* generate the fake module directly from the so file */
+    if (strendswith(output_file, ".fake"))
+        strcpy(output_file + strlen(output_file) - 5, ".so");
+
     /* generate app loader only for .exe */
     if (opts->shared || is_pe || strendswith(output_file, ".so"))
-	generate_app_loader = 0;
-
-    if (strendswith(output_file, ".fake")) fake_module = 1;
+	   generate_app_loader = 0;
 
     /* normalize the filename a bit: strip .so, ensure it has proper ext */
     if ((output_name = strrchr(output_file, '/'))) output_name++;
@@ -1242,13 +1243,6 @@ static void build(struct options* opts)
     strarray_add(spec_args, "-D_REENTRANT");
     if (opts->pic && !is_pe) strarray_add(spec_args, "-fPIC");
     strarray_add(spec_args, opts->shared ? "--dll" : "--exe");
-    if (fake_module)
-    {
-        strarray_add(spec_args, "--fake-module");
-        strarray_add(spec_args, "-o");
-        strarray_add(spec_args, output_file);
-    }
-    else
     {
         strarray_add(spec_args, "-o");
         strarray_add(spec_args, spec_o_name);
@@ -1315,7 +1309,6 @@ static void build(struct options* opts)
 
     spawn(opts->prefix, spec_args, 0);
     strarray_free (spec_args);
-    if (fake_module) return;  /* nothing else to do */
 
     /* link everything together now */
     link_args = get_link_args( opts, output_name );
@@ -1416,6 +1409,41 @@ static void build(struct options* opts)
     spawn(opts->prefix, link_args, 0);
     strarray_free (link_args);
 
+    /* extract the fake module */
+
+    if (!is_pe)
+    {
+        strarray *tool, *objcopy = build_tool_name(opts, TOOL_OBJCOPY);
+        char *tmp = get_temp_file( output_name, ".tmp" );
+        char *output_fake = strmake( "%s.fake", get_basename( output_path ) );
+        char buffer[4096];
+        FILE *in, *out;
+        size_t n;
+        int skip = 1;
+
+        tool = strarray_dup(objcopy);
+        strarray_add(tool, "-Obinary");
+        strarray_add(tool, "-j.init");
+        strarray_add(tool, "-j.text");
+        strarray_add(tool, "-j.fini");
+        strarray_add(tool, "-j.data");
+        strarray_add(tool, output_path);
+        strarray_add(tool, tmp );
+        spawn(opts->prefix, tool, 1);
+        strarray_free(tool);
+
+        in = fopen(tmp, "rb");
+        out = fopen(output_fake, "wb");
+        while ((n = fread(buffer, 1, sizeof(buffer), in)) > 0)
+        {
+            if (!memcmp(buffer, "\x4d\x5a\x90\x00", 4)) skip = 0;
+            if (skip) continue;
+            fwrite(buffer, 1, n, out);
+        }
+        fclose(out);
+        fclose(in);
+    }
+
     if (opts->debug_file && !strendswith(opts->debug_file, ".pdb"))
     {
         strarray *tool, *objcopy = build_tool_name(opts, TOOL_OBJCOPY);
-- 
2.27.0

>From 075affda9b24bcb036930f213828878a65a00899 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Fri, 12 Jun 2020 16:12:22 +0200
Subject: [PATCH 24/32] winegcc: Reduce fake module size after extraction.

---
 dlls/kernel32/tests/loader.c | 1 +
 tools/winegcc/winegcc.c      | 7 +++++++
 2 files changed, 8 insertions(+)

diff --git a/dlls/kernel32/tests/loader.c b/dlls/kernel32/tests/loader.c
index 926fa913866..45b4d450a83 100644
--- a/dlls/kernel32/tests/loader.c
+++ b/dlls/kernel32/tests/loader.c
@@ -1633,6 +1633,7 @@ todo_wine
         /* check position in file */
         map_offset = (DWORD_PTR)RtlImageRvaToVa(RtlImageNtHeader(ptr),    ptr,    map_rva, NULL) - (DWORD_PTR)ptr;
         dll_offset = (DWORD_PTR)RtlImageRvaToVa(RtlImageNtHeader(module), module, dll_rva, NULL) - (DWORD_PTR)module;
+        todo_wine
         ok(map_offset == dll_offset, "%s: File offset of mapped function (0x%x) does not match dll (0x%x)\n",
            func_name, map_offset, dll_offset);
 
diff --git a/tools/winegcc/winegcc.c b/tools/winegcc/winegcc.c
index 2b89e28671f..8ffa8ce5a7b 100644
--- a/tools/winegcc/winegcc.c
+++ b/tools/winegcc/winegcc.c
@@ -1442,6 +1442,13 @@ static void build(struct options* opts)
         }
         fclose(out);
         fclose(in);
+
+        tool = strarray_dup(objcopy);
+        strarray_add(tool, "--strip-all");
+        strarray_add(tool, "--file-alignment=512");
+        strarray_add(tool, output_fake );
+        spawn(opts->prefix, tool, 1);
+        strarray_free(tool);
     }
 
     if (opts->debug_file && !strendswith(opts->debug_file, ".pdb"))
-- 
2.27.0

>From faaac46d63dd13c8fcd1c432c5602400885e5ef9 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Wed, 17 Jun 2020 09:26:57 +0200
Subject: [PATCH 25/32] winebuild: Remove fake module generation code.

---
 tools/winebuild/build.h  |   2 -
 tools/winebuild/main.c   |   1 -
 tools/winebuild/res32.c  |  92 ------------------
 tools/winebuild/spec32.c | 200 ---------------------------------------
 4 files changed, 295 deletions(-)

diff --git a/tools/winebuild/build.h b/tools/winebuild/build.h
index a3ed4588f30..cf359a34727 100644
--- a/tools/winebuild/build.h
+++ b/tools/winebuild/build.h
@@ -313,9 +313,7 @@ extern void output_static_lib( DLLSPEC *spec, char **argv );
 extern void output_exports( DLLSPEC *spec );
 extern int load_res32_file( const char *name, DLLSPEC *spec );
 extern void output_resources( DLLSPEC *spec );
-extern void output_bin_resources( DLLSPEC *spec, unsigned int start_rva );
 extern void output_spec32_file( DLLSPEC *spec );
-extern void output_fake_module( DLLSPEC *spec );
 extern void output_def_file( DLLSPEC *spec, int import_only );
 extern void load_res16_file( const char *name, DLLSPEC *spec );
 extern void output_res16_data( DLLSPEC *spec );
diff --git a/tools/winebuild/main.c b/tools/winebuild/main.c
index efb86b705e1..b121747354a 100644
--- a/tools/winebuild/main.c
+++ b/tools/winebuild/main.c
@@ -683,7 +683,6 @@ int main(int argc, char **argv)
         if (fake_module)
         {
             if (spec->type == SPEC_WIN16) output_fake_module16( spec );
-            else output_fake_module( spec );
             break;
         }
         if (target_platform != PLATFORM_WINDOWS)
diff --git a/tools/winebuild/res32.c b/tools/winebuild/res32.c
index 8e1dca4d534..7445be936ef 100644
--- a/tools/winebuild/res32.c
+++ b/tools/winebuild/res32.c
@@ -508,14 +508,6 @@ void output_resources( DLLSPEC *spec )
     free_resource_tree( tree );
 }
 
-/* output a Unicode string in binary format */
-static void output_bin_string( const WCHAR *name )
-{
-    int i, len = strlenW(name);
-    put_word( len );
-    for (i = 0; i < len; i++) put_word( name[i] );
-}
-
 /* output a resource directory in binary format */
 static inline void output_bin_res_dir( unsigned int nb_names, unsigned int nb_ids )
 {
@@ -527,90 +519,6 @@ static inline void output_bin_res_dir( unsigned int nb_names, unsigned int nb_id
     put_word( nb_ids );    /* NumberOfIdEntries */
 }
 
-/* output the resource definitions in binary format */
-void output_bin_resources( DLLSPEC *spec, unsigned int start_rva )
-{
-    int k, nb_id_types;
-    unsigned int i, n, data_offset;
-    struct res_tree *tree;
-    struct res_type *type;
-    struct res_name *name;
-    const struct resource *res;
-
-    if (!spec->nb_resources) return;
-
-    tree = build_resource_tree( spec, &data_offset );
-    init_output_buffer();
-
-    /* output the resource directories */
-
-    for (i = nb_id_types = 0, type = tree->types; i < tree->nb_types; i++, type++)
-        if (!type->type->str) nb_id_types++;
-
-    output_bin_res_dir( tree->nb_types - nb_id_types, nb_id_types );
-
-    /* dump the type directory */
-
-    for (i = 0, type = tree->types; i < tree->nb_types; i++, type++)
-    {
-        put_dword( type->name_offset );
-        put_dword( type->dir_offset | 0x80000000 );
-    }
-
-    /* dump the names and languages directories */
-
-    for (i = 0, type = tree->types; i < tree->nb_types; i++, type++)
-    {
-        output_bin_res_dir( type->nb_names - type->nb_id_names, type->nb_id_names );
-        for (n = 0, name = type->names; n < type->nb_names; n++, name++)
-        {
-            put_dword( name->name_offset );
-            put_dword( name->dir_offset | 0x80000000 );
-        }
-
-        for (n = 0, name = type->names; n < type->nb_names; n++, name++)
-        {
-            output_bin_res_dir( 0, name->nb_languages );
-            for (k = 0, res = name->res; k < name->nb_languages; k++, res++)
-            {
-                put_dword( res->lang );
-                put_dword( res->data_offset );
-            }
-        }
-    }
-
-    /* dump the resource data entries */
-
-    for (i = 0, res = spec->resources; i < spec->nb_resources; i++, res++)
-    {
-        put_dword( data_offset + start_rva );
-        put_dword( res->data_size );
-        put_dword( 0 );
-        put_dword( 0 );
-        data_offset += (res->data_size + 3) & ~3;
-    }
-
-    /* dump the name strings */
-
-    for (i = 0, type = tree->types; i < tree->nb_types; i++, type++)
-    {
-        if (type->type->str) output_bin_string( type->type->str );
-        for (n = 0, name = type->names; n < type->nb_names; n++, name++)
-            if (name->name->str) output_bin_string( name->name->str );
-    }
-
-    /* resource data */
-
-    align_output( 4 );
-    for (i = 0, res = spec->resources; i < spec->nb_resources; i++, res++)
-    {
-        put_data( res->data, res->data_size );
-        align_output( 4 );
-    }
-
-    free_resource_tree( tree );
-}
-
 static unsigned int get_resource_header_size( const struct resource *res )
 {
     unsigned int size  = 5 * sizeof(unsigned int) + 2 * sizeof(unsigned short);
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index d3b6062175e..2451ed35a1e 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -49,7 +49,6 @@
 int needs_get_pc_thunk = 0;
 
 static const char builtin_signature[32] = "Wine builtin DLL";
-static const char fakedll_signature[32] = "Wine placeholder DLL";
 
 /* check if entry point needs a relay thunk */
 static inline int needs_relay( const ORDDEF *odp )
@@ -929,205 +928,6 @@ void output_spec32_file( DLLSPEC *spec )
 }
 
 
-/*******************************************************************
- *         output_fake_module
- *
- * Build a fake binary module from a spec file.
- */
-void output_fake_module( DLLSPEC *spec )
-{
-    static const unsigned char dll_code_section[] = { 0x31, 0xc0,          /* xor %eax,%eax */
-                                                      0xc2, 0x0c, 0x00 };  /* ret $12 */
-
-    static const unsigned char exe_code_section[] = { 0xb8, 0x01, 0x00, 0x00, 0x00,  /* movl $1,%eax */
-                                                      0xc2, 0x04, 0x00 };            /* ret $4 */
-
-    const unsigned int page_size = get_page_size();
-    const unsigned int section_align = page_size;
-    const unsigned int file_align = 0x200;
-    const unsigned int reloc_size = 8;
-    const unsigned int lfanew = 0x40 + sizeof(fakedll_signature);
-    const unsigned int nb_sections = 2 + (spec->nb_resources != 0);
-    const unsigned int text_size = (spec->characteristics & IMAGE_FILE_DLL) ?
-                                    sizeof(dll_code_section) : sizeof(exe_code_section);
-    unsigned char *resources;
-    unsigned int resources_size;
-    unsigned int image_size = 3 * section_align;
-
-    resolve_imports( spec );
-    output_bin_resources( spec, 3 * section_align );
-    resources = output_buffer;
-    resources_size = output_buffer_pos;
-    if (resources_size) image_size += (resources_size + section_align - 1) & ~(section_align - 1);
-
-    init_output_buffer();
-
-    put_word( 0x5a4d );       /* e_magic */
-    put_word( 0x40 );         /* e_cblp */
-    put_word( 0x01 );         /* e_cp */
-    put_word( 0 );            /* e_crlc */
-    put_word( lfanew / 16 );  /* e_cparhdr */
-    put_word( 0x0000 );       /* e_minalloc */
-    put_word( 0xffff );       /* e_maxalloc */
-    put_word( 0x0000 );       /* e_ss */
-    put_word( 0x00b8 );       /* e_sp */
-    put_word( 0 );            /* e_csum */
-    put_word( 0 );            /* e_ip */
-    put_word( 0 );            /* e_cs */
-    put_word( lfanew );       /* e_lfarlc */
-    put_word( 0 );            /* e_ovno */
-    put_dword( 0 );           /* e_res */
-    put_dword( 0 );
-    put_word( 0 );            /* e_oemid */
-    put_word( 0 );            /* e_oeminfo */
-    put_dword( 0 );           /* e_res2 */
-    put_dword( 0 );
-    put_dword( 0 );
-    put_dword( 0 );
-    put_dword( 0 );
-    put_dword( lfanew );
-
-    put_data( fakedll_signature, sizeof(fakedll_signature) );
-
-    put_dword( 0x4550 );                             /* Signature */
-    switch(target_cpu)
-    {
-    case CPU_x86:     put_word( IMAGE_FILE_MACHINE_I386 ); break;
-    case CPU_x86_64:  put_word( IMAGE_FILE_MACHINE_AMD64 ); break;
-    case CPU_POWERPC: put_word( IMAGE_FILE_MACHINE_POWERPC ); break;
-    case CPU_ARM:     put_word( IMAGE_FILE_MACHINE_ARMNT ); break;
-    case CPU_ARM64:   put_word( IMAGE_FILE_MACHINE_ARM64 ); break;
-    }
-    put_word( nb_sections );                         /* NumberOfSections */
-    put_dword( 0 );                                  /* TimeDateStamp */
-    put_dword( 0 );                                  /* PointerToSymbolTable */
-    put_dword( 0 );                                  /* NumberOfSymbols */
-    put_word( get_ptr_size() == 8 ?
-              IMAGE_SIZEOF_NT_OPTIONAL64_HEADER :
-              IMAGE_SIZEOF_NT_OPTIONAL32_HEADER );   /* SizeOfOptionalHeader */
-    put_word( spec->characteristics );               /* Characteristics */
-    put_word( get_ptr_size() == 8 ?
-              IMAGE_NT_OPTIONAL_HDR64_MAGIC :
-              IMAGE_NT_OPTIONAL_HDR32_MAGIC );       /* Magic */
-    put_byte(  7 );                                  /* MajorLinkerVersion */
-    put_byte(  10 );                                 /* MinorLinkerVersion */
-    put_dword( text_size );                          /* SizeOfCode */
-    put_dword( 0 );                                  /* SizeOfInitializedData */
-    put_dword( 0 );                                  /* SizeOfUninitializedData */
-    put_dword( section_align );                      /* AddressOfEntryPoint */
-    put_dword( section_align );                      /* BaseOfCode */
-    if (get_ptr_size() == 4) put_dword( 0 );         /* BaseOfData */
-    put_pword( 0x10000000 );                         /* ImageBase */
-    put_dword( section_align );                      /* SectionAlignment */
-    put_dword( file_align );                         /* FileAlignment */
-    put_word( 1 );                                   /* MajorOperatingSystemVersion */
-    put_word( 0 );                                   /* MinorOperatingSystemVersion */
-    put_word( 0 );                                   /* MajorImageVersion */
-    put_word( 0 );                                   /* MinorImageVersion */
-    put_word( spec->subsystem_major );               /* MajorSubsystemVersion */
-    put_word( spec->subsystem_minor );               /* MinorSubsystemVersion */
-    put_dword( 0 );                                  /* Win32VersionValue */
-    put_dword( image_size );                         /* SizeOfImage */
-    put_dword( file_align );                         /* SizeOfHeaders */
-    put_dword( 0 );                                  /* CheckSum */
-    put_word( spec->subsystem );                     /* Subsystem */
-    put_word( spec->dll_characteristics );           /* DllCharacteristics */
-    put_pword( (spec->stack_size ? spec->stack_size : 1024) * 1024 ); /* SizeOfStackReserve */
-    put_pword( page_size );                          /* SizeOfStackCommit */
-    put_pword( (spec->heap_size ? spec->heap_size : 1024) * 1024 );   /* SizeOfHeapReserve */
-    put_pword( page_size );                          /* SizeOfHeapCommit */
-    put_dword( 0 );                                  /* LoaderFlags */
-    put_dword( 16 );                                 /* NumberOfRvaAndSizes */
-
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT] */
-    if (resources_size)   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_RESOURCE] */
-    {
-        put_dword( 3 * section_align );
-        put_dword( resources_size );
-    }
-    else
-    {
-        put_dword( 0 );
-        put_dword( 0 );
-    }
-
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_EXCEPTION] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_SECURITY] */
-    put_dword( 2 * section_align );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_BASERELOC] */
-    put_dword( reloc_size );
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_DEBUG] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_COPYRIGHT] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_GLOBALPTR] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_TLS] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR] */
-    put_dword( 0 ); put_dword( 0 );   /* DataDirectory[15] */
-
-    /* .text section */
-    put_data( ".text\0\0", 8 );    /* Name */
-    put_dword( section_align );    /* VirtualSize */
-    put_dword( section_align );    /* VirtualAddress */
-    put_dword( text_size );        /* SizeOfRawData */
-    put_dword( file_align );       /* PointerToRawData */
-    put_dword( 0 );                /* PointerToRelocations */
-    put_dword( 0 );                /* PointerToLinenumbers */
-    put_word( 0 );                 /* NumberOfRelocations */
-    put_word( 0 );                 /* NumberOfLinenumbers */
-    put_dword( 0x60000020 /* CNT_CODE|MEM_EXECUTE|MEM_READ */ ); /* Characteristics  */
-
-    /* .reloc section */
-    put_data( ".reloc\0", 8 );     /* Name */
-    put_dword( section_align );    /* VirtualSize */
-    put_dword( 2 * section_align );/* VirtualAddress */
-    put_dword( reloc_size );       /* SizeOfRawData */
-    put_dword( 2 * file_align );   /* PointerToRawData */
-    put_dword( 0 );                /* PointerToRelocations */
-    put_dword( 0 );                /* PointerToLinenumbers */
-    put_word( 0 );                 /* NumberOfRelocations */
-    put_word( 0 );                 /* NumberOfLinenumbers */
-    put_dword( 0x42000040 /* CNT_INITIALIZED_DATA|MEM_DISCARDABLE|MEM_READ */ ); /* Characteristics */
-
-    /* .rsrc section */
-    if (resources_size)
-    {
-        put_data( ".rsrc\0\0", 8 );    /* Name */
-        put_dword( (resources_size + section_align - 1) & ~(section_align - 1) ); /* VirtualSize */
-        put_dword( 3 * section_align );/* VirtualAddress */
-        put_dword( resources_size );   /* SizeOfRawData */
-        put_dword( 3 * file_align );   /* PointerToRawData */
-        put_dword( 0 );                /* PointerToRelocations */
-        put_dword( 0 );                /* PointerToLinenumbers */
-        put_word( 0 );                 /* NumberOfRelocations */
-        put_word( 0 );                 /* NumberOfLinenumbers */
-        put_dword( 0x40000040 /* CNT_INITIALIZED_DATA|MEM_READ */ ); /* Characteristics */
-    }
-
-    /* .text contents */
-    align_output( file_align );
-    if (spec->characteristics & IMAGE_FILE_DLL)
-        put_data( dll_code_section, sizeof(dll_code_section) );
-    else
-        put_data( exe_code_section, sizeof(exe_code_section) );
-
-    /* .reloc contents */
-    align_output( file_align );
-    put_dword( 0 );   /* VirtualAddress */
-    put_dword( 0 );   /* SizeOfBlock */
-
-    /* .rsrc contents */
-    if (resources_size)
-    {
-        align_output( file_align );
-        put_data( resources, resources_size );
-    }
-    flush_output_buffer();
-}
-
-
 /*******************************************************************
  *         output_def_file
  *
-- 
2.27.0

>From 3e58708f35b5ae33d952fda5b402844b89e615be Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 15 Jun 2020 19:20:08 +0200
Subject: [PATCH 26/32] winebuild: Introduce wrap file to wrap exported
 symbols.

---
 tools/winebuild/build.h  |  1 +
 tools/winebuild/main.c   | 18 ++++++++++++++++--
 tools/winebuild/spec32.c | 34 ++++++++++++++++++++++++++++++++++
 tools/winegcc/winegcc.c  | 28 ++++++++++++++++++++++++++--
 4 files changed, 77 insertions(+), 4 deletions(-)

diff --git a/tools/winebuild/build.h b/tools/winebuild/build.h
index cf359a34727..ad3cb901ce5 100644
--- a/tools/winebuild/build.h
+++ b/tools/winebuild/build.h
@@ -315,6 +315,7 @@ extern int load_res32_file( const char *name, DLLSPEC *spec );
 extern void output_resources( DLLSPEC *spec );
 extern void output_spec32_file( DLLSPEC *spec );
 extern void output_def_file( DLLSPEC *spec, int import_only );
+extern void output_wrap_file( DLLSPEC *spec );
 extern void load_res16_file( const char *name, DLLSPEC *spec );
 extern void output_res16_data( DLLSPEC *spec );
 extern void output_bin_res16_data( DLLSPEC *spec );
diff --git a/tools/winebuild/main.c b/tools/winebuild/main.c
index b121747354a..eed45777b23 100644
--- a/tools/winebuild/main.c
+++ b/tools/winebuild/main.c
@@ -117,7 +117,8 @@ enum exec_mode_values
     MODE_STATICLIB,
     MODE_BUILTIN,
     MODE_FIXUP_CTORS,
-    MODE_RESOURCES
+    MODE_RESOURCES,
+    MODE_WRAP
 };
 
 static enum exec_mode_values exec_mode = MODE_NONE;
@@ -330,7 +331,8 @@ enum long_options_values
     LONG_OPT_SAVE_TEMPS,
     LONG_OPT_STATICLIB,
     LONG_OPT_SUBSYSTEM,
-    LONG_OPT_VERSION
+    LONG_OPT_VERSION,
+    LONG_OPT_WRAP
 };
 
 static const char short_options[] = "B:C:D:E:F:H:I:K:L:M:N:b:d:e:f:hkl:m:o:r:u:vw";
@@ -341,6 +343,7 @@ static const struct option long_options[] =
     { "def",           0, 0, LONG_OPT_DEF },
     { "exe",           0, 0, LONG_OPT_EXE },
     { "implib",        0, 0, LONG_OPT_IMPLIB },
+    { "wrap",          0, 0, LONG_OPT_WRAP },
     { "staticlib",     0, 0, LONG_OPT_STATICLIB },
     { "builtin",       0, 0, LONG_OPT_BUILTIN },
     { "as-cmd",        1, 0, LONG_OPT_ASCMD },
@@ -513,6 +516,9 @@ static char **parse_options( int argc, char **argv, DLLSPEC *spec )
         case LONG_OPT_IMPLIB:
             set_exec_mode( MODE_IMPLIB );
             break;
+        case LONG_OPT_WRAP:
+            set_exec_mode( MODE_WRAP );
+            break;
         case LONG_OPT_STATICLIB:
             set_exec_mode( MODE_STATICLIB );
             break;
@@ -702,6 +708,14 @@ int main(int argc, char **argv)
         output_def_file( spec, 0 );
         close_output_file();
         break;
+    case MODE_WRAP:
+        if (argv[0]) fatal_error( "file argument '%s' not allowed in this mode\n", argv[0] );
+        if (!spec_file_name) fatal_error( "missing .spec file\n" );
+        if (!parse_input_file( spec )) break;
+        open_output_file();
+        output_wrap_file( spec );
+        close_output_file();
+        break;
     case MODE_IMPLIB:
         if (!spec_file_name) fatal_error( "missing .spec file\n" );
         if (!parse_input_file( spec )) break;
diff --git a/tools/winebuild/spec32.c b/tools/winebuild/spec32.c
index 2451ed35a1e..b5dd5ffd1b9 100644
--- a/tools/winebuild/spec32.c
+++ b/tools/winebuild/spec32.c
@@ -1014,6 +1014,40 @@ void output_def_file( DLLSPEC *spec, int import_only )
 }
 
 
+/*******************************************************************
+ *         output_wrap_file
+ */
+void output_wrap_file( DLLSPEC *spec )
+{
+    DLLSPEC *spec32 = NULL;
+    const char *name;
+    int i;
+
+    if (target_cpu != CPU_x86 && target_cpu != CPU_x86_64) return;
+
+    if (spec->type == SPEC_WIN16)
+    {
+        spec32 = alloc_dll_spec();
+        add_16bit_exports( spec32, spec );
+        spec = spec32;
+    }
+
+    for (i = 0; i < spec->nb_entry_points; i++)
+    {
+        const ORDDEF *odp = &spec->entry_points[i];
+        if (odp->type != TYPE_STDCALL && odp->type != TYPE_VARARGS && odp->type != TYPE_CDECL)
+            continue;
+        if (odp->flags & (FLAG_FORWARD|FLAG_IMPORT|FLAG_EXT_LINK))
+            continue;
+
+        name = asm_name( get_link_name( odp ) );
+        output( "-Wl,--wrap=%s\n", name );
+        output( "-Wl,--defsym=__wrap_%s=__real_%s\n", name, name );
+    }
+    if (spec32) free_dll_spec( spec32 );
+}
+
+
 /*******************************************************************
  *         make_builtin_files
  */
diff --git a/tools/winegcc/winegcc.c b/tools/winegcc/winegcc.c
index 8ffa8ce5a7b..bb6a93eb52b 100644
--- a/tools/winegcc/winegcc.c
+++ b/tools/winegcc/winegcc.c
@@ -1072,9 +1072,9 @@ static void add_library( struct options *opts, strarray *lib_dirs, strarray *fil
 static void build(struct options* opts)
 {
     strarray *lib_dirs, *files;
-    strarray *spec_args, *link_args, *tool;
+    strarray *spec_args, *wrap_args, *link_args, *tool;
     char *output_file, *output_path;
-    const char *spec_o_name, *libgcc = NULL;
+    const char *spec_o_name, *wrap_name, *libgcc = NULL;
     const char *output_name, *spec_file, *lang;
     int generate_app_loader = 1;
     const char *crt_lib = NULL, *entry_point = NULL;
@@ -1310,6 +1310,29 @@ static void build(struct options* opts)
     spawn(opts->prefix, spec_args, 0);
     strarray_free (spec_args);
 
+    /* run winebuild to generate the .wrap file */
+    if (!is_pe && spec_file)
+    {
+        wrap_args = get_winebuild_args( opts );
+        wrap_name = get_temp_file(output_name, ".wrap");
+        if (opts->force_pointer_size)
+            strarray_add(wrap_args, strmake("-m%u", 8 * opts->force_pointer_size ));
+        strarray_add(wrap_args, "--wrap");
+        {
+            strarray_add(wrap_args, "-o");
+            strarray_add(wrap_args, wrap_name);
+        }
+        if (spec_file)
+        {
+            strarray_add(wrap_args, "-E");
+            strarray_add(wrap_args, spec_file);
+        }
+        if (opts->win16_app) strarray_add(wrap_args, "-m16");
+
+        spawn(opts->prefix, wrap_args, 0);
+        strarray_free (wrap_args);
+    }
+
     /* link everything together now */
     link_args = get_link_args( opts, output_name );
 
@@ -1339,6 +1362,7 @@ static void build(struct options* opts)
     }
 
     strarray_add(link_args, spec_o_name);
+    if (!is_pe && spec_file) strarray_add(link_args, strmake("@%s", wrap_name));
 
     if (is_pe)
     {
-- 
2.27.0

>From c48b1ad0e0f5069631080b3d40cd9510ee3dc126 Mon Sep 17 00:00:00 2001
From: Sebastian Lackner <sebastian@fds-team.de>
Date: Tue, 16 May 2017 04:37:52 +0200
Subject: [PATCH 27/32] krnl386.exe16: Do not abuse WOW32Reserved field for
 16-bit stack address.

---
 dlls/dbghelp/cpu_i386.c               |  6 ++---
 dlls/krnl386.exe16/kernel.c           |  6 ++---
 dlls/krnl386.exe16/kernel16_private.h | 11 ++++----
 dlls/krnl386.exe16/ne_module.c        |  6 ++---
 dlls/krnl386.exe16/ne_segment.c       | 20 +++++++--------
 dlls/krnl386.exe16/task.c             | 14 +++++------
 dlls/krnl386.exe16/thunk.c            | 36 +++++++++++++--------------
 dlls/krnl386.exe16/wowthunk.c         | 20 +++++++--------
 dlls/ntdll/signal_i386.c              |  2 +-
 dlls/system.drv16/system.c            |  2 +-
 dlls/toolhelp.dll16/toolhelp.c        |  6 ++---
 dlls/user.exe16/message.c             | 16 ++++++------
 dlls/user.exe16/user.c                |  4 +--
 dlls/user.exe16/window.c              |  2 +-
 include/winternl.h                    |  2 +-
 tools/winebuild/relay.c               |  2 +-
 16 files changed, 78 insertions(+), 77 deletions(-)

diff --git a/dlls/dbghelp/cpu_i386.c b/dlls/dbghelp/cpu_i386.c
index fd808a0d324..7d6723977a2 100644
--- a/dlls/dbghelp/cpu_i386.c
+++ b/dlls/dbghelp/cpu_i386.c
@@ -213,16 +213,16 @@ static BOOL i386_stack_walk(struct cpu_stack_walk *csw, STACKFRAME64 *frame,
         /* Init done */
         set_curr_mode((frame->AddrPC.Mode == AddrModeFlat) ? stm_32bit : stm_16bit);
 
-        /* cur_switch holds address of WOW32Reserved field in TEB in debuggee
+        /* cur_switch holds address of SystemReserved1[0] field in TEB in debuggee
          * address space
          */
         if (NtQueryInformationThread(csw->hThread, ThreadBasicInformation, &info,
                                      sizeof(info), NULL) == STATUS_SUCCESS)
         {
-            curr_switch = (DWORD_PTR)info.TebBaseAddress + FIELD_OFFSET(TEB, WOW32Reserved);
+            curr_switch = (DWORD_PTR)info.TebBaseAddress + FIELD_OFFSET(TEB, SystemReserved1[0]);
             if (!sw_read_mem(csw, curr_switch, &p, sizeof(p)))
             {
-                WARN("Can't read TEB:WOW32Reserved\n");
+                WARN("Can't read TEB:SystemReserved1[0]\n");
                 goto done_err;
             }
             next_switch = p;
diff --git a/dlls/krnl386.exe16/kernel.c b/dlls/krnl386.exe16/kernel.c
index 07a57d0d937..89ea5c042e7 100644
--- a/dlls/krnl386.exe16/kernel.c
+++ b/dlls/krnl386.exe16/kernel.c
@@ -47,8 +47,8 @@ static void thread_attach(void)
     /* allocate the 16-bit stack (FIXME: should be done lazily) */
     HGLOBAL16 hstack = WOWGlobalAlloc16( GMEM_FIXED, 0x10000 );
     kernel_get_thread_data()->stack_sel = GlobalHandleToSel16( hstack );
-    NtCurrentTeb()->WOW32Reserved = (void *)MAKESEGPTR( kernel_get_thread_data()->stack_sel,
-                                                        0x10000 - sizeof(STACK16FRAME) );
+    NtCurrentTeb()->SystemReserved1[0] = (void *)MAKESEGPTR( kernel_get_thread_data()->stack_sel,
+                                                             0x10000 - sizeof(STACK16FRAME) );
     memset( (char *)GlobalLock16(hstack) + 0x10000 - sizeof(STACK16FRAME), 0, sizeof(STACK16FRAME) );
 }
 
@@ -60,7 +60,7 @@ static void thread_detach(void)
 {
     /* free the 16-bit stack */
     WOWGlobalFree16( kernel_get_thread_data()->stack_sel );
-    NtCurrentTeb()->WOW32Reserved = 0;
+    NtCurrentTeb()->SystemReserved1[0] = 0;
     if (NtCurrentTeb()->Tib.SubSystemTib) TASK_ExitTask();
 }
 
